import { calendar_v3 } from "googleapis";
import { OAuth2Client, JWT, Compute, UserRefreshClient } from "google-auth-library";
import moment from "moment-timezone";
export interface GetEventsParams {
    user?: {
        accessToken: string;
        refreshToken: string;
    };
    from: moment.MomentInput;
    to: moment.MomentInput;
    calendarId?: string;
    auth?: string | OAuth2Client | JWT | Compute | UserRefreshClient;
}
export interface Slot {
    start: Date;
    end: Date;
}
export declare const getEventsFromSingleCalendar: ({ user, from, to, calendarId, auth, }: GetEventsParams) => Promise<calendar_v3.Schema$Event[]>;
export declare const getEventsFromAllCalendars: (params: Pick<GetEventsParams, "user" | "auth" | "from" | "to">) => Promise<calendar_v3.Schema$Event[]>;
export declare const getSlots: (params: GetEventsParams & {
    log?: boolean | undefined;
    slotDuration?: number | undefined;
    slots?: number | undefined;
    days?: number[] | undefined;
    daily?: {
        timezone: string;
        from: [number, (number | undefined)?, (number | undefined)?];
        to: [number, (number | undefined)?, (number | undefined)?];
    } | undefined;
    slotFilter?: ((slot: Slot) => boolean) | undefined;
    logger?: ((...args: any[]) => void) | undefined;
}) => Promise<Slot[]>;
